;----------[ normal includes ... ]---------\
.686
.model flat,stdcall
.mmx
option casemap :none
option proc:private
include \masm32\include\windows.inc
include \masm32\include\user32.inc
include \masm32\include\gdi32.inc
include \masm32\include\kernel32.inc
includelib \masm32\lib\user32.lib
includelib \masm32\lib\kernel32.lib
includelib \masm32\lib\gdi32.lib
include sDraw.inc
includelib sDraw.lib
;------------------------------------------/

WS_EX_LAYERED     equ      00080000h
LWA_COLORKEY      equ      00000001h
LWA_ALPHA         equ      00000002h



WND_STYLE equ WS_POPUP or WS_CAPTION or WS_VISIBLE or WS_SYSMENU

.data
	wc WNDCLASSEX <>
	wndClass db "WindowClass1",0
	wndTitle db "sDraw Example",0
	lpszKnob4 db "KNOB4.ilb",0
	lpszCable db "cable1.ilb",0
	lpszDude db "Dude_0.ilb",0
	
	hwnd1 dd 0
	knob4 		dd 0
	imgCable dd 0
	imgDude dd 0
	
	IsFirstRun dd 1
.code

Cable struct
	first	POINT <>
	p1	POINT <>
	p3	POINT <>
	last 	POINT <>
	inert1	POINT <>
	inert3	POINT <>
	IsResting	dd ?
	dwColor	dd  151515h
Cable ends


m2m macro p1,p2
	push p2
	pop p1
endm

movf macro arg1,arg2
	mov arg1,12345678h
	org $-4
	real4 arg2
endm

AnimateCable proc uses eax ebx ecx edx esi edi pCable
	local p1x,p3x,p1y,p3y
	local I1:POINT,I3:POINT ; intertias, in real4
	local TM:POINT ; in int
	mov ecx,pCable
	assume ecx:ptr Cable
	.if !ecx || [ecx].IsResting
		ret
	.endif
	
	
	;----[ compute TM ]--------------\
	mov eax,[ecx].first.x
	add eax,[ecx].last.x
	sar eax,1
	mov TM.x,eax
	
	mov eax,[ecx].first.y
	mov edx,[ecx].last.y
	.if sdword ptr eax<edx
		mov eax,edx
	.endif
	add eax,50
	mov edx,[ecx].first.x
	sub edx,[ecx].last.x
	.if SIGN?
		neg edx
	.endif
	sar edx,2
	add eax,edx
	
	
	
	mov TM.y,eax
	;--------------------------------/
	
	;-----[ compute p1x,p3x ]-------[
	; p1x = avg(tmx,firstx
	mov ebx,TM.x
	mov edx,ebx
	add ebx,[ecx].first.x
	add edx,[ecx].last.x
	sar ebx,1
	sar edx,1
	mov p1x,ebx
	mov p3x,edx	
	;-------------------------------/
	;------[ compute p1y,p3y ]--------[
	mov ebx,TM.y
	lea ebx,[ebx+ebx*2]
	mov edx,ebx
	add ebx,[ecx].first.y
	add edx,[ecx].last.y
	sar ebx,1
	sar edx,1
	mov p1y,ebx
	mov p3y,edx
	m2m p1y,TM.y
	m2m p3y,TM.y
	;---------------------------------/
	
	
.data
	ccvar1 real4 0.2 ; speed
	ccvar2 real4 0.7 ; elasticity
.code
	
	@@INERTCAB macro _PTX,_PT,_INER
		fild _PTX
		fisub [ecx]._PT
		fmul ccvar1
		fadd [ecx]._INER
		fild [ecx]._PT
		fadd ST,ST(1)
		fistp [ecx]._PT
		fmul ccvar2
		fstp [ecx]._INER
		
		;mov eax,_PTX
		;sub eax,[ecx]._PT
		;sar eax,2
		;add eax,[ecx]._INER
		;add [ecx]._PT,eax
		;sar eax,1
		;mov [ecx]._INER,eax
	endm
	
	
	
	;---[ compute I1, anim P1 ]-----\
	@@INERTCAB p1x,p1.x,inert1.x
	@@INERTCAB p1y,p1.y,inert1.y
	;-------------------------------/
	
	;---[ compute I3, anim P3 ]-----\
	@@INERTCAB p3x,p3.x,inert3.x
	@@INERTCAB p3y,p3.y,inert3.y
	;-------------------------------/
	
	mov esi,7FFFFFFFh
	movf edi,0.1
	mov eax,[ecx].inert1.x
	mov ebx,[ecx].inert1.y
	mov edx,[ecx].inert3.x
	mov ecx,[ecx].inert3.y
	and eax,esi
	and ebx,esi
	and ecx,esi
	and edx,esi
	
	.if eax<edi && ebx<edi && ecx<edi && edx<edi
		mov ecx,pCable
		mov [ecx].IsResting,1
	.endif
	
	
	
	
	assume ecx:nothing
	ret
AnimateCable endp



Shader1 proc x,y,dwColor
	invoke sDrawRectROP,x,y,5,5,151515h,SD_SUBSAT
	ret
Shader1 endp


Shader3 proc uses ecx x,y,dwColor
.data
	SH3WR dd 0
	SH3RD dd 0
	SH3HX dd 8 dup (?)
	SH3HY dd 8 dup (?)
.code
	invoke sBltTint,x,y,5,5,0,0,dwColor
	mov ecx,SH3WR
	and ecx,7
	m2m SH3HX[ecx*4],x
	m2m SH3HY[ecx*4],y
	inc SH3WR
	.if SH3WR>4
		mov ecx,SH3RD
		and ecx,7		
		invoke sBltAdd,SH3HX[ecx*4],SH3HY[ecx*4],5,5,12,0
		inc SH3RD
	.endif	
	
	ret
Shader3 endp
Shader3_init proc
	mov SH3WR,0
	mov SH3RD,0
	ret
Shader3_init endp
Shader3_finish proc
	mov eax,SH3RD
	mov ecx,eax
	.while eax!=SH3WR
		and ecx,7
		invoke sBltAdd,SH3HX[ecx*4],SH3HY[ecx*4],5,5,6,0
		inc eax
		inc ecx
	.endw
	
	ret
Shader3_finish endp

DrawCable proc pCable,IsSelected
	;----[ SHADOW ]-------------------------------------[
	mov ecx,pCable
	
	
	
	assume ecx:ptr Cable
	mov eax,10
	add [ecx].first.x,2
	add [ecx].first.y,2
	add [ecx].p1.x,eax
	add [ecx].p1.y,eax
	add [ecx].p3.x,eax
	add [ecx].p3.y,eax
	.if IsSelected
		add [ecx].last.x,eax
		add [ecx].last.y,eax
	.endif
	
	;invoke sDrawBSplineShade,ecx,20,0,Shader1,5
	sub [ecx].first.x,2
	sub [ecx].first.y,2
	sub [ecx].p1.x,eax
	sub [ecx].p1.y,eax
	sub [ecx].p3.x,eax
	sub [ecx].p3.y,eax
	.if IsSelected
		sub [ecx].last.x,eax
		sub [ecx].last.y,eax
	.endif
	;---------------------------------------------------/
	
	;------[ CABLE ]----------------------------------\
	invoke sdSetSourceSprite,imgCable
	invoke Shader3_init
	mov ecx,pCable
	invoke sDrawBSplineShade,pCable,20,[ecx].dwColor,Shader3,5
	invoke Shader3_finish
	
	;-------------------------------------------------/
	;mov ecx,pCable
	;invoke sBltTint,[ecx].p1.x,[ecx].p1.y,5,5,0,0,[ecx].dwColor
	;invoke sBltTint,[ecx].p3.x,[ecx].p3.y,5,5,0,0,[ecx].dwColor
	;invoke sDrawRectROP,[ecx].p1.x,[ecx].p1.y,8,8,303030h,SD_ADDSAT
	;invoke sDrawRectROP,[ecx].p3.x,[ecx].p3.y,8,8,303030h,SD_ADDSAT
	
	
	
	assume ecx:nothing
	ret
DrawCable endp


DrawSpline proc uses eax ebx ecx edx esi edi
	local pt:POINT
	
	invoke GetCursorPos,addr pt
	invoke ScreenToClient,hwnd1,addr pt
.data
	cab1 Cable <<400,130>,<0,0>,<0,0>,<200,0>,<0,0>,<0,0>,0,00800000h>
	cab2 Cable <<400,0>,<0,0>,<0,0>,<10,50>,<0,0>,<0,0>,0,0>
	cab3 Cable <<0,100>,<0,0>,<0,0>,<0,0>,<0,0>,<0,0>,0,804000h>
	cab4 Cable <<0,10>,<0,0>,<0,0>,<0,0>,<0,0>,<0,0>,0,100>
	cab5 Cable <<0,140>,<0,0>,<0,0>,<400,0>,<0,0>,<0,0>,0,100>
	cab6 Cable <<0,160>,<0,0>,<0,0>,<400,0>,<0,0>,<0,0>,0,100>
	cab7 Cable <<0,100>,<0,0>,<0,0>,<400,0>,<0,0>,<0,0>,0,100>
	cab8 Cable <<0,170>,<0,0>,<0,0>,<400,100>,<0,0>,<0,0>,0,100>
.code
	
	mov eax,pt.x
	mov ecx,pt.y
	
	mov cab3.last.x,eax
	mov cab3.last.y,ecx
	mov cab3.IsResting,0
	
	
	invoke AnimateCable,addr cab1
	invoke AnimateCable,addr cab2
	invoke AnimateCable,addr cab3
	invoke AnimateCable,addr cab4
	invoke AnimateCable,addr cab5
	invoke AnimateCable,addr cab6
	invoke AnimateCable,addr cab7
	invoke AnimateCable,addr cab8
	invoke DrawCable,addr cab1,0
	invoke DrawCable,addr cab2,0
	invoke DrawCable,addr cab4,0
	invoke DrawCable,addr cab5,0
	invoke DrawCable,addr cab6,0
	invoke DrawCable,addr cab7,0
	invoke DrawCable,addr cab8,0
	
	
	invoke DrawCable,addr cab3,1
	
.data
	Line1 POINT <200,200>
	Line2 POINT <100,200>
.code
	
	
	ret
DrawSpline endp

TestDraw proc uses eax ebx ecx edx esi edi hWnd
	local prevy
	invoke sdStart,hWnd ; start drawing on window
	jz _ret ; window is not visible
	
	;------[ clear background only on first run ]--[
	;.if IsFirstRun
		invoke sDrawRect,0,0,2000,2000,0FF00FFh;0CCCCCCh
	;	mov IsFirstRun,0
	;.endif
	;----------------------------------------------/
	
	;---------[ draw the oscillo ]-------------------[
	.data
		someseed1 dd 0
	.code
	mov prevy,150
	xor ebx,ebx
	.while ebx<400
		mov eax,someseed1
		imul eax,2135
		add eax,2145123
		xor eax,21425948
		mov someseed1,eax
		and eax,0FFFFFFh
		xor edx,edx
		mov ecx,200
		div ecx
		add edx,50
		push edx
		lea eax,[ebx+4]
		invoke sDrawFastLine,ebx,prevy,eax,edx,00FF00h
		pop prevy
		add ebx,4
	.endw
	;------------------------------------------------/
	
	
	invoke DrawSpline
	
	;--------[ draw the dude ]----------------------[
	invoke GetTickCount
	shr eax,5
	xor edx,edx
	mov ecx,10*2-1
	div ecx
	sub edx,9
	jns @F
		neg edx
	@@:
	imul edx,47
	inc edx
	mov SD_TransparentColor,111110000000000011111000b
	
	invoke sBltTransParam,200,150,46,57,edx,0,imgDude
	;-----------------------------------------------/
	
	
	
	invoke sdEnd ; end drawing on window
_ret:	ret
TestDraw endp





;----------[ creates an arbitrary window ]---------------------[
MakeOneWindow proc wid,hei,pFunc,pTitle,dwStyle1
	local rect:RECT
	local hInst
	
	mov wc.cbSize,sizeof  wc
	
	push pFunc
	pop wc.lpfnWndProc
	invoke LoadCursor,0,IDC_ARROW
	mov wc.hCursor,eax
	invoke GetModuleHandle,0
	mov wc.hInstance,eax
	mov hInst,eax
	mov wc.lpszClassName,offset wndClass
	invoke RegisterClassEx,addr wc
	;-------------------------------------------/
	;-----[ adjust window size ]---------\
	mov rect.left,0
	mov rect.top,0
	push wid
	pop rect.right
	push hei
	pop rect.bottom
	invoke AdjustWindowRect,addr rect,dwStyle1,0
	mov eax,rect.right
	sub eax,rect.left
	mov ecx,rect.bottom
	sub ecx,rect.top
	;------------------------------------/
	
	invoke CreateWindowEx,WS_EX_LAYERED,wc.lpszClassName,pTitle,dwStyle1,50,50,eax,ecx,0,0,hInst,0
	ret
MakeOneWindow endp
;--------------------------------------------------------------/









SetLayeredWindowAttributes proto :DWORD,:DWORD,:DWORD,:DWORD


;--------------[ main window's procedure ]------------------------[
WinProc proc hWnd,msg,w,l
	.if msg==WM_TIMER
		invoke TestDraw,hWnd
	.elseif msg==WM_CLOSE
		invoke PostQuitMessage,0
	.elseif msg==WM_PAINT
		invoke ValidateRect,hWnd,0
		invoke TestDraw,hWnd
	.elseif msg==WM_KEYDOWN && w==VK_ESCAPE
		invoke PostQuitMessage,0
	.elseif msg==WM_CREATE
		m2m hwnd1,hWnd
		invoke SetLayeredWindowAttributes,hWnd,0FF00FFh,255,LWA_COLORKEY
	.else
		invoke DefWindowProc,hWnd,msg,w,l
		ret
	.endif
	xor eax,eax
	ret
WinProc endp
;------------------------------------------------------------------/






;===========================[ main procedure ]=======================================[
main proc
	local msg:MSG
	;-------[ init sDraw, and load images ]------------------[
	invoke InitSDraw,400,300
	;--------------------------------------------------------/
	;------[ make the main window ]-----------------------------[
	invoke MakeOneWindow,400,300,WinProc,addr wndTitle,WND_STYLE
	;-----------------------------------------------------------/
	invoke SetTimer,eax,1,20,0
	invoke sdSpriteFromILBFile,addr lpszKnob4
	mov knob4,eax
	
	invoke sdSpriteFromILBFile,addr lpszCable
	mov imgCable,eax
	
	invoke sdSpriteFromILBFile,addr lpszDude
	mov imgDude,eax
	
	;---[ message-loop ]-----------------------[
	.while TRUE
		invoke GetMessage, ADDR msg,0,0,0
		.BREAK .IF (!eax)
		invoke TranslateMessage, ADDR msg
		invoke DispatchMessage, ADDR msg
	.endw
	;------------------------------------------/
	
	invoke FreeSDraw
	
	ret
main endp
;====================================================================================/






start:
	invoke main
	invoke ExitProcess,0
end start
